#define VIDEO_WIDTH 80    // 
#define VIDEO_HEIGHT 25   // 
#define VIDEO_RAM 0xb8000 // 

int tty_cursor;    // 
int tty_attribute; //  


// tty
void init_tty() 
{
	tty_cursor = 0;
	tty_attribute = 7;
}

//   
void textcolor(char c)
{
	tty_attribute = c;
}

// 
void clear()
{
	char *video = VIDEO_RAM;
	int i;

	for (i = 0; i < VIDEO_HEIGHT*VIDEO_WIDTH; i++) {
		*(video + i*2) = ' ';
	}
  
	tty_cursor = 0;
}


//     
void putchar(char c){
	char *video = VIDEO_RAM;
	int i;

	switch (c) {
		case '\n': //    
			tty_cursor+=VIDEO_WIDTH;
			tty_cursor-=tty_cursor%VIDEO_WIDTH;
			break;
		default:
			*(video + tty_cursor*2) = c;
			*(video + tty_cursor*2+1) = tty_attribute;
			tty_cursor++;
			break;
	}

  //     ,      
	if(tty_cursor>VIDEO_WIDTH*VIDEO_HEIGHT){
		for(i=VIDEO_WIDTH*2;i<=VIDEO_WIDTH*VIDEO_HEIGHT*2+VIDEO_WIDTH*2;i++){
			*(video+i-VIDEO_WIDTH*2)=*(video+i);
		}
		tty_cursor-=VIDEO_WIDTH;
	}
}

// ,  -
void puts(const char *s)
{
	while(*s) {
		putchar(*s);
		s++;
	}
}
