#define		INT_INT		0x8E
#define		INT_TRAP	0x8F

#define		IRQ(func)\
	void func(void);\
	asm(#func ": pusha \n call _" #func " \n movb $0x20, %al \n outb %al, $0x20 \n popa \n iret \n");\
	void _ ## func(void)


#define		sti()\
	asm("sti")

#define		cli()\
	asm("cli")

void iinstall(unsigned char vector, void (*func)(), unsigned char type);
void isetup();
